program Small_code_Twiss
use my_own_little_code_utilities
implicit none
type(my_taylor) Z(2),r2,x,p,PHASE_ADVANCE,INVARIANT
type(my_taylor)  x2_average,x_average
type(normalform) NORMAL
type(inverse_dragt_finn) idf
type(my_map) M,id,a_cs
real(dp) L,k1,fix(2),ma(2,2),h
complex(dp) zz
integer i,n,mf,j,i1,i2,k
integer beta(2),twoalpha(2),gamma(2)
type(magnet) :: lattice(6*10)
type(ray) r
!   mad-x lattice
!   L : drift, L= 1.0;
!   QF   : QUADRUPOLE, L=1.0, K1=1.0;  
!   QD   : QUADRUPOLE, L=1.0, K1=-1.0; 
!   sf  : sextupole,  K2= 2.0;
!s1 : LINE=  10*(QF,sf,L,QD,sf,L);
Write(6,*) " Creating the simple lattice: 10*(QF,sf,L,QD,sf,L) "
L=1.0_dp
h=  twopi/20/L
do i=1,10
 k=(i-1)*6
LATTICE(1+k)%NAME="QF"
 LATTICE(1+k)%L=L
 LATTICE(1+k)%BN=0.0_DP
 LATTICE(1+k)%BN(0)=h
 LATTICE(1+k)%h=h
 LATTICE(1+k)%BN(1)=1.0_DP
 LATTICE(1+k)%N=100
LATTICE(2+k)%NAME="SF"
 LATTICE(2+k)%L=0.0_DP
 LATTICE(2+k)%BN=0.0_DP
 LATTICE(2+k)%BN(2)=2.0_DP
 LATTICE(2+k)%h=0
 LATTICE(2+k)%N=0
LATTICE(3+k)%NAME="L"
 LATTICE(3+k)%L=1.0_DP
 LATTICE(3+k)%BN=0.0_DP
 LATTICE(3+k)%h=0
 LATTICE(3+k)%N=1
LATTICE(4+k)%NAME="QD"
 LATTICE(4+k)%L=L
 LATTICE(4+k)%BN=0.0_DP
 LATTICE(4+k)%BN(1)=-1.0_DP
 LATTICE(4+k)%BN(0)=h
 LATTICE(4+k)%h=h
 LATTICE(4+k)%N=100
LATTICE(5+k)%NAME="SF"
 LATTICE(5+k)%L=0.0_DP
 LATTICE(5+k)%BN=0.0_DP
 LATTICE(5+k)%BN(2)=2.0_DP
 LATTICE(5+k)%h=0
 LATTICE(5+k)%N=0
LATTICE(6+k)%NAME="L"
 LATTICE(6+k)%L=1.0_DP
 LATTICE(6+k)%BN=0.0_DP
 LATTICE(6+k)%h=0
 LATTICE(6+k)%N=1
enddo
 
my_order=4

fix=0.0_dp  ! fixed point
call find_closed_orbit( fix,LATTICE,1)
write(6,*) " fix point = ",fix
id=1
r%z=fix+id ! initialize the ray as --> ray = Fixed point + Identity (Taylor map)

!  Computing a one-turn map to order my_order

 CALL track_lattice( r,LATTICE,1,1)
 
m=r%z    

NORMAL=M    ! normalizing the map

mf=10
open(unit=MF,file='invariant_functions.txt')

write(mf,*) " Tune ", normal%tune  ! Result of the Normal form on the one-turn map
write(mf,*) " Tune shift with amplitude", normal%dtune_da  ! Result of the Normal form on the one-turn map

!!!!!   Track lattice functions !!!!

beta(1)=0; beta(2)=2;  !  coefficient of p**2 of invariant r2
gamma(1)=2; gamma(2)=0;  !  coefficient of x**2 of invariant r2
twoalpha(1)=1; twoalpha(2)=1;  !  coefficient of xp of invariant r2  = 2*alpha

r%z=fix+normal%a_t   ! initialize the ray as --> ray = Fixed point + A



x=1.0_dp.mono.1 ;p=1.0_dp.mono.2; r2 = x**2+p**2 ;


PHASE_ADVANCE=0.0_DP

  CALL CANONIZE( r%z,PHASE_ADVANCE,a_cs ) 
 
 INVARIANT=r2*a_cs**(-1)
 write(mf,*) " ############################################################## " 
 write(mf,*) " Before ",lattice(1)%name
 write(mf,*) "      sqrt(beta)     ,         alpha        ,          gamma"
 write(mf,*) sqrt(INVARIANT.sub.beta),0.5_dp*(INVARIANT.sub.twoalpha),INVARIANT.sub.gamma
 Write(mf,*) "Total Phase advance including nonlinear part "
 CALL PRINT(PHASE_ADVANCE,MF)
 write(mf,*) " ############################################################## " 


DO J=1,SIZE(LATTICE)
 CALL track_magnet( r,LATTICE(J) )

  CALL CANONIZE( r%z,PHASE_ADVANCE,a_cs ) 
 
 INVARIANT=r2*a_cs**(-1)
 write(mf,*) " ############################################################## " 
 write(mf,*) " After ",lattice(j)%name
 write(mf,*) "      sqrt(beta)     ,         alpha        ,          gamma"
 write(mf,*) sqrt(INVARIANT.sub.beta),0.5_dp*(INVARIANT.sub.twoalpha),INVARIANT.sub.gamma
 Write(mf,*) "Total Phase advance including nonlinear part "
 CALL PRINT(PHASE_ADVANCE,MF)
 write(mf,*) " ############################################################## " 

ENDDO

Write(mf,*) "Invariant at the end "

call print(INVARIANT,mf)

 write(mf,*) "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% " 
 Write(mf,*) "Final  Phase advance including nonlinear part "
 CALL PRINT(PHASE_ADVANCE,MF)
 Write(mf,*) " One-turn map results "
 write(mf,*) " Tune ", normal%tune  ! Result of the Normal form on the one-turn map
 write(mf,*) " Tune shift with amplitude", normal%dtune_da  ! Result of the Normal form on the one-turn map
 write(mf,*) "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% " 

! Non-Linear Beta function defined as <x**2> = beta * J + dbeta/dJ * J**2 + ... 

call average(x**2,A_cs,x2_average,use_J=.true.)

write(mf,*) " Non-Linear Beta function defined as <x**2> = beta * J + dbeta/dJ * J**2 + ..."
call print(x2_average,mf)

call average(x,A_cs,x_average,use_J=.true.)

!  Non-Linear dispersion defined as <x> = d<x>/dJ * J +  ...
write(mf,*) " Non-Linear dispersion defined as <x> = d<x>/dJ * J +  ..."
call print(x_average,mf)

close(MF)

end program Small_code_Twiss
